﻿$(function () {
    var CP = window.CanvasRenderingContext2D && CanvasRenderingContext2D.prototype;
    if (CP && CP.lineTo) {

        CP.drawPolygon = function (Xcenter, Ycenter, numberOfSides) {
            var size = 12;
            Xcenter = parseInt(Xcenter);
            Ycenter = parseInt(Ycenter);
            var d = 0;
            numberOfSides = parseInt(numberOfSides);
            if (numberOfSides == 4)
                d = 45 * Math.PI / 180;
            else
                d = (-30) * Math.PI / 180;
            this.fillStyle = '#FF0000';
            this.beginPath();
            if (numberOfSides == 2) {
                this.moveTo(Xcenter, Ycenter - size * 1.5);
                this.lineTo(Xcenter + size * 0.3, Ycenter);
                this.lineTo(Xcenter, Ycenter + size * 1.5);
                this.lineTo(Xcenter - size * 0.3, Ycenter);
                this.moveTo(Xcenter, Ycenter - size * 1.5);
                this.fill();
            } else {
                if (numberOfSides == 4)
                    d = 45 * Math.PI / 180;
                this.moveTo(Xcenter + size * Math.cos(d), Ycenter + size * Math.sin(d));
                for (var i = 1; i <= numberOfSides; i += 1) {
                    this.lineTo(Xcenter + size * Math.cos(d + (i * 2 * Math.PI / numberOfSides)), Ycenter + size * Math.sin(d + (i * 2 * Math.PI / numberOfSides)));
                    this.fill();
                }
            }
        }

        CP.dashedLine = function (x, y, x2, y2, st, dashArray) {
            this.beginPath();
            if (st != "dashed") {
                this.moveTo(x, y);
                this.lineTo(x2, y2);
            } else {
                if (!dashArray) dashArray = [10, 5];
                if (dashLength == 0) dashLength = 0.001; // Hack for Safari
                var dashCount = dashArray.length;
                x = parseInt(x);
                y = parseInt(y);
                this.moveTo(x, y);
                var dashIndex = 0,
                    draw = true;
                var dx = (x2 - x),
                    dy = (y2 - y);
                if (dx == 0) {
                    var dashLength = dashArray[dashIndex++ % dashCount];
                    var distRemaining = dy;
                    while (distRemaining >= 0.1) {
                        var dashLength = dashArray[dashIndex++ % dashCount];
                        if (dashLength > distRemaining) dashLength = distRemaining;
                        var yStep = dashLength;
                        if (dy < 0) yStep = -yStep;
                        y += yStep;
                        this[draw ? 'lineTo' : 'moveTo'](x, y);
                        distRemaining -= dashLength;
                        draw = !draw;
                    }
                } else {
                    var slope = dy / dx;
                    var distRemaining = Math.sqrt(dx * dx + dy * dy);
                    while (distRemaining >= 0.1) {
                        var dashLength = dashArray[dashIndex++ % dashCount];
                        if (dashLength > distRemaining)
                            dashLength = distRemaining;
                        var xStep = Math.sqrt(dashLength * dashLength / (1 + slope * slope));
                        if (dx < 0) xStep = -xStep;
                        x += xStep;
                        y += slope * xStep;
                        this[draw ? 'lineTo' : 'moveTo'](x, y);
                        distRemaining -= dashLength;
                        draw = !draw;
                    }
                }
            }
            this.stroke();
        }
    }



    chart = new App.Models.Chart({
        color: 'black'
    });
    draw = new App.Views.Draw({
        model: chart,
        el: '#rysunek'
    });
    cell = new App.Views.Cell({
        model: chart,
        el: '#rysunek'
    });

    router = new Router();
    Backbone.history.start();
})