App.Models.Chart = Backbone.Model.extend({

    defaults:{
        bgcolor:"white",
        color: "black",
		group: "p1",
		system: "oblique",
		ps:  0,
		axn: 1,
        xmax: 0,
        ymax: 0,
        x2: 0,
        y2: 0,
        Th: 120,
        ca: 0.86602540378443864676372317075294,
        si: -0.5,
        ta: -0.57735026918962576450914878050196,
        A: 250,
        B: 250,
		ab: false,
		clg: true,
        clc: true,
		showCell: false
	},
	
	draw: function (ctx, shift, x_0, y_0, x_1, y_1) {
    var nB = Math.floor(chart.get('ymax') / (chart.get('B') * chart.get('ca'))) + 1;
    var nA = Math.floor((chart.get('xmax') + Math.round(chart.get('ymax') * (chart.get('ta') > 0 ? chart.get('ta') : -1 * chart.get('ta')))) / chart.get('A')) + 1;
    var a, b;

    for (b = -1; b <= nB; b++) {
        var ly0_ = b * chart.get('B') + y_0;
        ly0 = Math.round(ly0_ * chart.get('ca'));
        var ly1_ = b * chart.get('B') + y_1;
        ly1 = Math.round(ly1_ * chart.get('ca'));
        for (a = -1; a <= nA; a++) {
            var lx0 = a * chart.get('A') + x_0 - Math.round(ly0_ * chart.get('si')) - shift;
            var lx1 = a * chart.get('A') + x_1 - Math.round(ly1_ * chart.get('si')) - shift;

            ctx.beginPath();
            ctx.moveTo(lx0, ly0);
            ctx.lineTo(lx1, ly1);
            ctx.stroke();
        }
    }
	},

	hexdraw: function (ctx, x1, y1, x2, y2) {
    var x13, y13, x23, y23, i, j;
    var nB = Math.floor(chart.get('ymax') / (chart.get('B') * chart.get('ca'))) + 1;
    var nA = Math.floor((chart.get('xmax') + Math.round(chart.get('ymax') * (chart.get('ta') > 0 ? chart.get('ta') : -1 * chart.get('ta')))) / chart.get('A')) + 1;
    for (i = -1; i <= nA; i++)
        for (j = -1; j <= nB; j++) {
            y13 = y1 + chart.get('A') * j;
            x13 = (chart.get('A') * i + x1) - Math.round(y13 * 0.5);
            y13 = Math.round(y13 * 0.8660254037844);
            y23 = y2 + chart.get('A') * j;
            x23 = (chart.get('A') * i + x2) - Math.round(y23 * 0.5);
            y23 = Math.round(y23 * 0.8660254037844);

            ctx.beginPath();
            ctx.moveTo(x13, y13);
            ctx.lineTo(x23, y23);
            ctx.stroke();
    }
	},



	cnvs_draw: function (e) {
    x = e.clientX;
    y = e.clientY-50;
    if (App.Old.drw == 1) {
        var c = document.getElementById("myCanvas");
        var ctx = c.getContext("2d");
        if (App.Old.x0 < 0) {
            App.Old.x0 = x;
			App.Old.y0 = y;
        }

        if (chart.get('group') == "symetria nietranslacyjna") {
            var ps = document.getElementById("ps");
            var numPoints = chart.get('axn');

            if (numPoints > 1) {
                for (var n = 0; n < numPoints; n++) {
                    var theta = ((Math.PI * 2) / numPoints) * (n + 1);
                    var sin = Math.sin(theta);
                    var cos = Math.cos(theta);
                    var i1 = chart.get('x2') + (App.Old.x0 - chart.get('x2')) * cos - (App.Old.y0 - chart.get('y2')) * sin;
                    var i2 = chart.get('y2') + (App.Old.x0 - chart.get('x2')) * sin + (App.Old.y0 - chart.get('y2')) * cos;
                    var j1 = chart.get('x2') + (x - chart.get('x2')) * cos - (y - chart.get('y2')) * sin;
                    var j2 = chart.get('y2') + (x - chart.get('x2')) * sin + (y - chart.get('y2')) * cos;
                    ctx.beginPath();
                    ctx.moveTo(i1, i2);
                    ctx.lineTo(j1, j2);
                    ctx.stroke();
                    if (ps.checked) {
                        ctx.beginPath();
                        ctx.moveTo(chart.get('xmax') - i1, i2);
                        ctx.lineTo(chart.get('xmax') - j1, j2);
                        ctx.stroke();
                    }
                }
            } else {
                ctx.beginPath();
                ctx.moveTo(App.Old.x0, App.Old.y0);
                ctx.lineTo(x, y);
                ctx.stroke();

                if (ps.checked) {
                    ctx.beginPath();
                    ctx.moveTo(chart.get('xmax') - App.Old.x0, App.Old.y0);
                    ctx.lineTo(chart.get('xmax') - x, y);
                    ctx.stroke();
                }
            }
        } else {

            if (chart.get('system') == "hexagonal") {
                var y11 = Math.round(App.Old.y0 * 1.154700538379); /*y11=y1/cos30*/
                var x11 = App.Old.x0 + Math.round(App.Old.y0 * 0.5773502691896); /*x11=x1+y1*tg30*/

                var y22 = Math.round(y * 1.154700538379); /*y11=y1/cos30*/
                var x22 = x + Math.round(y * 0.5773502691896); /*x11=x1+y1*tg30*/
                y22 = y22 - chart.get('A') * (Math.floor(y11 / chart.get('A')));
                x22 = x22 - chart.get('A') * (Math.floor(x11 / chart.get('A')));

                y11 = y11 % chart.get('A');
                x11 = x11 % chart.get('A');
                chart.hexdraw(ctx, x11, y11, x22, y22);

                switch (chart.get('group')) {
                case 'p6mm':
                    chart.hexdraw(ctx, -1 * y11, -1 * x11, -1 * y22, -1 * x22);
                    chart.hexdraw(ctx, y11 - x11, y11, y22 - x22, y22);
                    chart.hexdraw(ctx, x11, x11 - y11, x22, x22 - y22);
                    chart.hexdraw(ctx, y11, x11, y22, x22);
                    chart.hexdraw(ctx, x11 - y11, -1 * y11, x22 - y22, -1 * y22);
                    chart.hexdraw(ctx, -1 * x11, y11 - x11, -1 * x22, y22 - x22);
                case 'p6':
                    chart.hexdraw(ctx, -1 * x11, -1 * y11, -1 * x22, -1 * y22);
                    chart.hexdraw(ctx, y11, y11 - x11, y22, y22 - x22);
                    chart.hexdraw(ctx, x11 - y11, x11, x22 - y22, x22);
                case 'p3':
                    chart.hexdraw(ctx, -1 * y11, x11 - y11, -1 * y22, x22 - y22);
                    chart.hexdraw(ctx, y11 - x11, -1 * x11, y22 - x22, -1 * x22);
                    break;
                case 'p3m1':
                    chart.hexdraw(ctx, -1 * y11, x11 - y11, -1 * y22, x22 - y22);
                    chart.hexdraw(ctx, y11 - x11, -1 * x11, y22 - x22, -1 * x22);
                    chart.hexdraw(ctx, -1 * y11, -1 * x11, -1 * y22, -1 * x22);
                    chart.hexdraw(ctx, y11 - x11, y11, y22 - x22, y22);
                    chart.hexdraw(ctx, x11, x11 - y11, x22, x22 - y22);
                    break;
                case 'p31m':
                    chart.hexdraw(ctx, -1 * y11, x11 - y11, -1 * y22, x22 - y22);
                    chart.hexdraw(ctx, y11 - x11, -1 * x11, y22 - x22, -1 * x22);
                    chart.hexdraw(ctx, y11, x11, y22, x22);
                    chart.hexdraw(ctx, -1 * y11 + x11, -1 * y11, -1 * y22 + x22, -1 * y22);
                    chart.hexdraw(ctx, -1 * x11, -1 * x11 + y11, -1 * x22, -1 * x22 + y22);
                    break;
                }
            } else {
                var shift = 0;
                if (chart.get('ta') < 0)
                    shift -= Math.round(chart.get('ymax') * chart.get('ta'));

                var y_0 = Math.round(App.Old.y0 / chart.get('ca'));
                var y_1 = Math.round(y / chart.get('ca'));

                var x_0 = Math.round(App.Old.y0 * chart.get('ta')) + shift;

                x_0 += App.Old.x0;
                var x_1 = Math.round(y * chart.get('ta')) + shift;
                x_1 += x;
                y_1 = y_1 - chart.get('B') * Math.floor(y_0 / chart.get('B'));
                x_1 = x_1 - chart.get('A') * Math.floor(x_0 / chart.get('A'));

                y_0 = y_0 % chart.get('B');
                x_0 = x_0 % chart.get('A');
                chart.draw(ctx, shift, x_0, y_0, x_1, y_1);

                switch (chart.get('group')) {
                case "p2":
                    chart.draw(ctx, shift, -1 * x_0, -1 * y_0, -1 * x_1, -1 * y_1);
                    break;
                case "pm":
                    chart.draw(ctx, shift, -1 * x_0, y_0, -1 * x_1, y_1);
                    break;
                case "pg":
                    var bb = Math.floor(0.5 * chart.get('B'));
                    chart.draw(ctx, shift, -1 * x_0, y_0 + bb, -1 * x_1, y_1 + bb);
                    break;
                case "cm":
                    var aa = Math.floor(0.5 * chart.get('A'));
                    var bb = Math.floor(0.5 * chart.get('B'));
                    chart.draw(ctx, shift, -1 * x_0, y_0, -1 * x_1, y_1);
                    chart.draw(ctx, shift, x_0 + aa, y_0 + bb, x_1 + aa, y_1 + bb);
                    chart.draw(ctx, shift, aa - x_0, y_0 + bb, aa - x_1, y_1 + bb);
                    break;
                case "p2mm":
                    chart.draw(ctx, shift, -1 * x_0, y_0, -1 * x_1, y_1);
                    chart.draw(ctx, shift, -1 * x_0, -1 * y_0, -1 * x_1, -1 * y_1);
                    chart.draw(ctx, shift, x_0, -1 * y_0, x_1, -1 * y_1);
                    break;
                case "p2mg":
                    var aa = Math.floor(0.5 * chart.get('A'));
                    chart.draw(ctx, shift, -1 * x_0, -1 * y_0, -1 * x_1, -1 * y_1);
                    chart.draw(ctx, shift, -1 * x_0 + aa, y_0, -1 * x_1 + aa, y_1);
                    chart.draw(ctx, shift, x_0 + aa, -1 * y_0, x_1 + aa, -1 * y_1);
                    break;
                case "p2gg":
                    var aa = Math.floor(0.5 * chart.get('A'));
                    var bb = Math.floor(0.5 * chart.get('B'));
                    chart.draw(ctx, shift, -1 * x_0, -1 * y_0, -1 * x_1, -1 * y_1);
                    chart.draw(ctx, shift, -1 * x_0 + aa, y_0 + bb, -1 * x_1 + aa, y_1 + bb);
                    chart.draw(ctx, shift, x_0 + aa, -1 * y_0 + bb, x_1 + aa, -1 * y_1 + bb);
                    break;
                case "cmm":
                    var aa = Math.floor(0.5 * chart.get('A'));
                    var bb = Math.floor(0.5 * chart.get('B'));
                    chart.draw(ctx, shift, -1 * x_0, y_0, -1 * x_1, y_1);
                    chart.draw(ctx, shift, -1 * x_0, -1 * y_0, -1 * x_1, -1 * y_1);
                    chart.draw(ctx, shift, x_0, -1 * y_0, x_1, -1 * y_1);
                    chart.draw(ctx, shift, x_0 + aa, y_0 + bb, x_1 + aa, y_1 + bb);
                    chart.draw(ctx, shift, -1 * x_0 + aa, y_0 + bb, -1 * x_1 + aa, y_1 + bb);
                    chart.draw(ctx, shift, -1 * x_0 + aa, -1 * y_0 + bb, -1 * x_1 + aa, -1 * y_1 + bb);
                    chart.draw(ctx, shift, x_0 + aa, -1 * y_0 + bb, x_1 + aa, -1 * y_1 + bb);
                    break;
                case "p4":
                    chart.draw(ctx, shift, -1 * y_0, x_0, -1 * y_1, x_1);
                    chart.draw(ctx, shift, -1 * x_0, -1 * y_0, -1 * x_1, -1 * y_1);
                    chart.draw(ctx, shift, y_0, -1 * x_0, y_1, -1 * x_1);
                    break;
                case "p4mm":
                    chart.draw(ctx, shift, -1 * y_0, x_0, -1 * y_1, x_1);
                    chart.draw(ctx, shift, -1 * x_0, -1 * y_0, -1 * x_1, -1 * y_1);
                    chart.draw(ctx, shift, y_0, -1 * x_0, y_1, -1 * x_1);
                    chart.draw(ctx, shift, -1 * x_0, y_0, -1 * x_1, y_1);
                    chart.draw(ctx, shift, x_0, -1 * y_0, x_1, -1 * y_1);
                    chart.draw(ctx, shift, y_0, x_0, y_1, x_1);
                    chart.draw(ctx, shift, -1 * y_0, -1 * x_0, -1 * y_1, -1 * x_1);
                    break;
                case "p4gm":
                    chart.draw(ctx, shift, -1 * y_0, x_0, -1 * y_1, x_1);
                    chart.draw(ctx, shift, -1 * x_0, -1 * y_0, -1 * x_1, -1 * y_1);
                    chart.draw(ctx, shift, y_0, -1 * x_0, y_1, -1 * x_1);
                    var aa = Math.floor(0.5 * chart.get('A'));
                    var bb = Math.floor(0.5 * chart.get('B'));
                    chart.draw(ctx, shift, -1 * x_0 + aa, y_0 + bb, -1 * x_1 + aa, y_1 + bb);
                    chart.draw(ctx, shift, x_0 + aa, -1 * y_0 + bb, x_1 + aa, -1 * y_1 + bb);
                    chart.draw(ctx, shift, y_0 + bb, x_0 + aa, y_1 + bb, x_1 + aa);
                    chart.draw(ctx, shift, -1 * y_0 + bb, -1 * x_0 + aa, -1 * y_1 + bb, -1 * x_1 + aa);
                    break;
                }
            }
        }
	  }
	  App.Old.x0 = x;
	  App.Old.y0 = y;
	},
	
	urlRoot: App.API+'/chart'

});