function findPos(obj) {
    var curleft = 0,
        curtop = 0;
    if (obj.offsetParent) {
        do {
            curleft += obj.offsetLeft;
            curtop += obj.offsetTop;
        } while (obj = obj.offsetParent);
        return {
            x: curleft,
            y: curtop
        };
    }
    return undefined;
}

function rgbToHex(r, g, b) {
    if (r > 255 || g > 255 || b > 255)
        throw "Invalid color component";
    return ((r << 16) | (g << 8) | b).toString(16);
}


function initCPicker(canvasName, model, method) {
    var c = document.getElementById(canvasName);
    var canvOK = 1;
    try {
        c.getContext("2d");
    } catch (er) {
        canvOK = 0;
    }
    if (canvOK == 1) {
        var ctx = c.getContext("2d");
        var h = c.height;
        var w = c.width;
        var grd1 = ctx.createLinearGradient(0, 90, w, 90);
		grd1.addColorStop(0.01,"#FF0000");
		grd1.addColorStop(0.166,"yellow");
		grd1.addColorStop(0.332,"#00FF00");
		grd1.addColorStop(0.489,"skyblue");
		grd1.addColorStop(0.664,"#0000FF");
		grd1.addColorStop(0.83,"deeppink");
		grd1.addColorStop(0.98,"#FF0000");
		grd1.addColorStop(0.981,"#777777");
		grd1.addColorStop(0.982,"#777777");
        ctx.fillStyle = grd1;
        ctx.fillRect(0, 0, w, h / 2);
        var grd2 = ctx.createLinearGradient(0, 90, w, 90);
        grd2.addColorStop(0, "black");
        grd2.addColorStop(1, "white");
        ctx.fillStyle = grd2;
        ctx.fillRect(0, h / 2, w, h / 2);

        $('#' + canvasName).mousemove(function (e) {
            var pos = findPos(this);
            var x = e.pageX - pos.x;
            var y = e.pageY - pos.y;
            var coord = "x=" + x + ", y=" + y;
            var c = this.getContext('2d');
            var p = c.getImageData(x, y, 1, 1).data;
            var hex = "#" + ("000000" + rgbToHex(p[0], p[1], p[2])).slice(-6);
            var h = this.height;
            if (y < Math.floor(h * 0.4)) {
                var w = this.width;
                var grd2 = ctx.createLinearGradient(0, 90, w, 90);
                grd2.addColorStop(0.07, "black");
                grd2.addColorStop("0.5", hex);
                grd2.addColorStop(0.93, "white");
                ctx.fillStyle = grd2;
                ctx.fillRect(0, h / 2, w, h / 2);
            }
        });

        $('#' + canvasName).click(function (e) {
            var pos = findPos(this);
            var x = e.pageX - pos.x;
            var y = e.pageY - pos.y;
            var coord = "x=" + x + ", y=" + y;
            var c = this.getContext('2d');
            var p = c.getImageData(x, y, 1, 1).data;
            var hex = "#" + ("000000" + rgbToHex(p[0], p[1], p[2])).slice(-6);
			if(model!=null)
			{
				App.Undo={"type":"color", "method":method, "hex":model.get(method,hex) };
				model.set(method,hex);
				$('#iRedo').hide();
			    $('#iUndo').show();
//            		$(document).trigger(colorSetterEvent, [hex]);
			}
        });
    }
}


/*
function initCPicker(canvasName, colorSetterEvent) {
    var c = document.getElementById(canvasName);
    var canvOK = 1;
    try {
        c.getContext("2d");
    } catch (er) {
        canvOK = 0;
    }
    if (canvOK == 1) {
        $(document).on(colorSetterEvent, function (e, eventInfo) {
            subscribers = $('.subscribers-' + colorSetterEvent);
            subscribers.trigger(colorSetterEvent + 'Handler', [eventInfo]);
        });

        var ctx = c.getContext("2d");
        var h = c.height;
        var w = c.width;
        var grd1 = ctx.createLinearGradient(0, 90, w, 90);
        grd1.addColorStop(0, "black");
        grd1.addColorStop("0.2", "magenta");
        grd1.addColorStop("0.4", "blue");
        grd1.addColorStop("0.43", "green");
        grd1.addColorStop("0.7", "yellow");
        grd1.addColorStop("0.83", "orange");
        grd1.addColorStop(1, "red");
        ctx.fillStyle = grd1;
        ctx.fillRect(0, 0, w, h / 2);
        var grd2 = ctx.createLinearGradient(0, 90, w, 90);
        grd2.addColorStop(0, "black");
        grd2.addColorStop(1, "white");
        ctx.fillStyle = grd2;
        ctx.fillRect(0, h / 2, w, h / 2);

        $('#' + canvasName).mousemove(function (e) {
            var pos = findPos(this);
            var x = e.pageX - pos.x;
            var y = e.pageY - pos.y;
            var coord = "x=" + x + ", y=" + y;
            var c = this.getContext('2d');
            var p = c.getImageData(x, y, 1, 1).data;
            var hex = "#" + ("000000" + rgbToHex(p[0], p[1], p[2])).slice(-6);
            var h = this.height;
            if (y < Math.floor(h * 0.4)) {
                var w = this.width;
                var grd2 = ctx.createLinearGradient(0, 90, w, 90);
                grd2.addColorStop(0, "black");
                grd2.addColorStop("0.5", hex);
                grd2.addColorStop(1, "white");
                ctx.fillStyle = grd2;
                ctx.fillRect(0, h / 2, w, h / 2);
            }
        });

        $('#' + canvasName).click(function (e) {
            var pos = findPos(this);
            var x = e.pageX - pos.x;
            var y = e.pageY - pos.y;
            var coord = "x=" + x + ", y=" + y;
            var c = this.getContext('2d');
            var p = c.getImageData(x, y, 1, 1).data;
            var hex = "#" + ("000000" + rgbToHex(p[0], p[1], p[2])).slice(-6);
            $(document).trigger(colorSetterEvent, [hex]);
        });
    }
}*/